/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	AICCLogForProperties
//	変更履歴
//		2004.02.01	新規作成
//

package jp.co.ntt.lms.lo.scorm.util;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.HashMap;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerException;

import jp.co.ntt.lms.lo.scorm.kernel.exception.SystemException;

import org.xml.sax.SAXException;

/**
 *	AICCLogForProperties クラス<br>
 *	ini形式のAOCCLogの具象クラス<br>
 */
public class AICCLogForProperties {

	/** キーがセクション名、値が、「キーがキー名、値が値のHashMap」のHashMap */
	private HashMap rootMap;

	/**
	 * デフォルトコンストラクタ
	 */
	public AICCLogForProperties() {}

	/**
	 * 指定された(Windowsの)ini形式のAICCログファイルを読み込み、初期化を行う。<br>
	 * ファイルを一行ずつ読み込み、HashMap rootMapにキーがセクション名、値に「キー
	 * が(iniファイルの)キー名、値が(iniファイルの値)」のHashMapを格納する<br>
	 *
	 * @param filename	ini形式のAICCログファイル名を指定する
	 */
	public void initialize(String filename)
		throws
			UnsupportedEncodingException,
			FileNotFoundException,
			IOException,
			ParserConfigurationException,
			SAXException,
			TransformerException,
			SystemException {

		String encoding = SG.get("LearningLogEncoding");

		BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(filename)));

		try {
			rootMap = new HashMap();
			HashMap sectionMap = null;

			for (int i = 1;; i++) {
				String line = br.readLine();

				if (line == null) {
					break;
				}

				if (line.trim().length() <= 2) {
					continue;
				}

				if ((line.charAt(0) == '#') || (line.charAt(0) == ';')) {
					continue;
				}

				if ((line.charAt(0) == '[') && (line.charAt(line.length() - 1) == ']')) {
					String sectionName = line.substring(1, line.length() - 1);

					sectionMap = new HashMap();

					rootMap.put(sectionName, sectionMap);

					continue;
				}

				if (sectionMap == null) {
					throw new SystemException(line + "(" + i + ") : sectionMap = " + sectionMap);
				}

				int positionOfEqual = line.indexOf('=');

				if (positionOfEqual <= 0) {
					continue;
				}

				String key;
				String value = "";

				key = line.substring(0, positionOfEqual);

				if ((positionOfEqual + 1) < line.length()) {
					value = line.substring(positionOfEqual + 1, line.length());
				}

				sectionMap.put(key, URLDecoder.decode(value, encoding));
			}
		}
		finally {
			br.close();
		}
	}

	/**
	 * 指定されたセクションのHashMapを取得する
	 *
	 * @param section セクション名を指定する
	 * @return 該当のセクション名に一致するHashMapを返却する
	 */
	public HashMap get(String section) {
		return (HashMap)rootMap.get(section);
	}

	/**
	 * 指定されたセクション、キーのデータを取得する
	 *
	 * @param section セクション名を指定する
	 * @param key キー名を指定する
	 * @return 該当のセクションに存在するキーの値を返却する
	 */
	public String get(String section, String key) {
		HashMap map = get(section);

		if (map == null) {
			return null;
		}

		return (String)map.get(key);
	}
}
